config/routes.rb
Rails.application.routes.draw do
  #get 'home/index'

  root 'home#index'

  resources :home

# links
  get 'status' => 'home#status_file'
  get 'whitespace' => 'home#whitespace_file'
  get 'code' => 'home#code_file'
  get 'edgeNGram_filter' => 'home#edgeNGram_file'
  get 'lowercase' => 'home#lowercase_file'
  get 'asciifolding' => 'home#asciifolding_file'
  get 'download_file' => 'home#download_file'

# Output page
  get 'output' => "home#output"

#Back to index page

  root :controller => 'static', :action => '/'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/home.rb
class Home < ActiveRecord::Base
  attr_accessor :esurl, :esport, :httpbasicusername, :httpbasicpassword, :searchtext,:textcontent
end

app/controllers/home_controller.rb
class HomeController < ApplicationController

  def index
    @elasticsearch = Home.new()
  end

  # Opens generated files in browser
  def status_file
    send_file "#{Rails.root}/es_output/es_status_check.json", :filename => "es_status_check.json", :disposition => 'inline', :type => "text/plain"
  end

  def whitespace_file
    send_file "#{Rails.root}/es_output/whitespace_tokenizer.json", :filename => "whitespace_tokenizer.json", :disposition => 'inline', :type => "text/plain"
  end

  def code_file
    send_file "#{Rails.root}/es_output/code_token_filter.json", :filename => "code_token_filter.json", :disposition => 'inline', :type => "text/plain"
  end

  def edgeNGram_file
    send_file "#{Rails.root}/es_output/edgeNGram_filter_token_filter.json", :filename => "edgeNGram_filter_token_filter.json", :disposition => 'inline', :type => "text/plain"
  end

  def lowercase_file
    send_file "#{Rails.root}/es_output/lowercase_token_filter.json", :filename => "lowercase_token_filter.json", :disposition => 'inline', :type => "text/plain"
  end

  def asciifolding_file
    send_file "#{Rails.root}/es_output/asciifolding_token_filter.json", :filename => "asciifolding_token_filter.json", :disposition => 'inline', :type => "text/plain"
  end

  def back_home
   redirect_to root_path
  end

  # Fires off when download file link is clicked

  def download_file
    directory_path  = "#{Rails.root}/es_output"
    timestamp       = Time.now.strftime "%Y-%m-%d-%s"
    es_zip_name     = "elasticsearch-#{timestamp}.zip"
    bundle_filename = "#{directory_path}/"+es_zip_name

    filenames = "es_output/*.json"
    %x{ cd #{directory_path}}
    %x{  zip -r  #{bundle_filename} #{filenames}}

    if File.exists?("#{Rails.root}/es_output/elasticsearch-#{timestamp}.zip")
      send_file "#{Rails.root}/es_output/elasticsearch-#{timestamp}.zip", :filename => "elasticsearch-#{timestamp}.zip", :disposition => "attachment",  :type => "application/zip"
    end
  end

# Checking Status of calls
  def check_status(response)
   if response != "200"
     @status = false
     #alert: "Something went wrong, check your input or try again."
   end
    if response == "200"
      @status = true
      #notice: "Please click the links below to see output."
      #flash[:notice] = "Please click the links below to see output."
    end
  end


  def create

    require 'net/http'
    require 'uri'
    require 'json'
    require 'csv'
    require 'zip'


    begin
      @elasticsearch = Home.new(form_params)

      es_url= @elasticsearch.esurl
      es_port= @elasticsearch.esport
      http_basic_username= @elasticsearch.httpbasicusername
      http_basic_password= @elasticsearch.httpbasicpassword
      text_content= @elasticsearch.textcontent
      search_text= @elasticsearch.searchtext

      text_content_uri = URI.parse("http://#{es_url}:#{es_port}/gitlab-production/_analyze?pretty")
      text_content_request = Net::HTTP::Get.new(text_content_uri)
      text_content_request.basic_auth(http_basic_username,http_basic_password)
      text_content_request.content_type = "application/json"
      text_content_request.body = JSON.dump({
        "tokenizer" => "whitespace",
        "filter" => ["code", "edgeNGram_filter", "lowercase", "asciifolding"],
        "explain" => true,
        "text" => text_content
      })

      text_content_req_options = {
        use_ssl: text_content_uri.scheme == "https",
      }

      text_content_response = Net::HTTP.start(text_content_uri.hostname, text_content_uri.port, text_content_req_options) do |http|
        http.request(text_content_request)
      end

      parsed = JSON.parse(text_content_response.body)
      puts "Text Content Analyze Response code: #{text_content_response.code}"

      search_term_uri = URI.parse("http://#{es_url}:#{es_port}/gitlab-production/_analyze?pretty")
      search_term_request = Net::HTTP::Get.new(search_term_uri)
      search_term_request.basic_auth(http_basic_username,http_basic_password)
      search_term_request.content_type = "application/json"
      search_term_request.body = JSON.dump({
        "analyzer" => "code_search_analyzer",
        "text" => search_text
      })

      search_term_req_options = {
        use_ssl: search_term_uri.scheme == "https",
      }

      search_term_response = Net::HTTP.start(search_term_uri.hostname, search_term_uri.port, search_term_req_options) do |http|
        http.request(search_term_request)
      end

      search_term_parsed = JSON.parse(search_term_response.body)
      puts "Search Term Analyze Response code: #{search_term_response.code}"

      code_search_analyzed_search_terms = []
      search_term_parsed["tokens"].each{|t| code_search_analyzed_search_terms << t["token"]}

      whitespaced_search_terms = search_text.split(' ')
      lowercase_search_terms   = search_text.downcase.split(' ')

      @token_explanation = {
        whitespace:{
          match: nil,
          order: 1
        },
        code:{
          match: nil,
          order: 2
        },
        edgeNGram_filter:{
          match: nil,
          order: 3
        },
        lowercase:{
          match: nil,
          order: 4
        },
        asciifolding:{
          match: nil,
          order: 5
        }
      }

      tokenizer_term_array = []
      token_filter_term_array = []

      File.open("es_output/#{parsed["detail"]["tokenizer"]["name"]}_tokenizer.json", "w") do |json|
        json << JSON.pretty_generate(parsed["detail"]["tokenizer"]["tokens"])
      end

      parsed["detail"]["tokenizer"]["tokens"].each do |t_object|
        whitespaced_search_terms.each do |term|

          if t_object["token"] == term
            tokenizer_term_array << term
          end
        end
      end

      if tokenizer_term_array.uniq.sort == whitespaced_search_terms.uniq.sort
        @token_explanation[parsed["detail"]["tokenizer"]["name"].to_sym][:match] = true
      else
        @token_explanation[parsed["detail"]["tokenizer"]["name"].to_sym][:match] = false
      end

      parsed["detail"]["tokenfilters"].each do |tokenfilter_object|
        File.open("es_output/#{tokenfilter_object["name"]}_token_filter.json", "w") do |json|
          json << JSON.pretty_generate(tokenfilter_object["tokens"])
        end

                  # If the tokenfilter_object name is lowercase or asciifolding
            # otherwise, we need to remove the lowercase or asciifolding
        if tokenfilter_object["name"] == "asciifolding"
          tokenfilter_object["tokens"].each do |t_object|  
            code_search_analyzed_search_terms.each do |term|
              if t_object["token"] == term
                token_filter_term_array << term
              end
            end
          end

          if token_filter_term_array.uniq.sort == code_search_analyzed_search_terms.sort
           
            @token_explanation[tokenfilter_object["name"].to_sym][:match] = true
            token_filter_term_array = []
          else
            @token_explanation[tokenfilter_object["name"].to_sym][:match] = false
            token_filter_term_array = []
          end
        elsif tokenfilter_object["name"] == "lowercase"
          tokenfilter_object["tokens"].each do |t_object|
            lowercase_search_terms.each do |term|
              if t_object["token"] == term
                token_filter_term_array << term
              end
            end
          end

          if token_filter_term_array.uniq.sort == lowercase_search_terms.sort
            @token_explanation[tokenfilter_object["name"].to_sym][:match] = true
            token_filter_term_array = []
          else
            @token_explanation[tokenfilter_object["name"].to_sym][:match] = false
            token_filter_term_array = []
          end
        else
          tokenfilter_object["tokens"].each do |t_object|
            whitespaced_search_terms.each do |term|
              if t_object["token"] == term
                token_filter_term_array << term
              end
            end
          end

          if token_filter_term_array.uniq.sort == whitespaced_search_terms.sort
            @token_explanation[tokenfilter_object["name"].to_sym][:match] = true
            token_filter_term_array = []
          else
            @token_explanation[tokenfilter_object["name"].to_sym][:match] = false
            token_filter_term_array = []
          end
        end
      end

      #Get token explanation and populate file.
      File.open("es_output/token_report.json", "w") { |file| file.puts "#{JSON.pretty_generate(@token_explanation)}"}

      #Get common cluster stats and populate file.
      File.open("es_output/es_status_check.json", "w") { |file| file.puts "Cluster Health"}

      #Get cluster health
      uri         = URI.parse("http://#{es_url}:#{es_port}/_cat/health?v&pretty")
      uri_request = Net::HTTP::Get.new(uri)
      uri_request.basic_auth(http_basic_username,http_basic_password)
      uri_options = {
        use_ssl: uri.scheme == "https",
      }

      uri_response = Net::HTTP.start(uri.hostname, uri.port, uri_options) do |http|
        http.request(uri_request)
      end

      # Write Health to file
      File.open("es_output/es_status_check.json", "a") { |file| file.puts uri_response.body}
      File.open("es_output/es_status_check.json", "a") { |file| file.puts ""}
      File.open("es_output/es_status_check.json", "a") { |file| file.puts "Allocation"}

      # Get cluster allocation
      uri = URI.parse("http://#{es_url}:#{es_port}/_cat/allocation?v&pretty&h=shards,disk.indices,disk.used,disk.avail,disk.total,disk.percent,node")
      uri_request = Net::HTTP::Get.new(uri)
      uri_request.basic_auth(http_basic_username,http_basic_password)
      uri_options = {
        use_ssl: uri.scheme == "https",
      }

      uri_response = Net::HTTP.start(uri.hostname, uri.port, uri_options) do |http|
        http.request(uri_request)
      end
      # Write Health to file

app/helpers/home_helper.rb
module HomeHelper
end

app/views/home/_elasticsearch_form.html.erb
<%= form_for @elasticsearch, url: home_index_path, remote: true do |form| %>
<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">
    <title>Checkout example for Bootstrap</title>
  </head>

  <body class="bg-light">

    <div class="container">
      <div class="py-5 text-center">
        <p class="lead">Fill out the fields and click 'GET DATA'.</p>
      </div>

      <div class="row">
        <div class="col-md-2 order-md-2 mb-2">
          <h4 class="d-flex justify-content-between align-items-center mb-3"></h4>
        </div>

        <div class="col-md-8 order-md-1">
          <form class="needs-validation" novalidate>
            <div class="row">
              <div class="col-md-6 mb-3">
                <label for="esurl">ELASTICSEARCH URL</label>
                <%= form.text_field :esurl, required: true, class: 'form-control', value: "172.19.0.2"%>
              </div>
              <div class="col-md-6 mb-3">
                <label for="esport">ELASTICSEARCH PORT</label>
                <%= form.text_field :esport, required: true, class: 'form-control', value: "9200" %>
              </div>
            </div>

            <div class="row">
              <div class="col-md-6 mb-3">
                <label for="httpbasicusername">HTTP BASIC USERNAME</label>
                <%= form.text_field :httpbasicusername, class: 'form-control', placeholder: "optional" %>
              </div>
              <div class="col-md-6 mb-3">
                <label for="httpbasicpassword">HTTP BASIC PASSWORD</label>
                <%= form.text_field :httpbasicpassword, class: 'form-control', placeholder: "optional"%>
              </div>
            </div>

            <hr class="mb-4">

            <div class="row">
              <div class="col-md-6 mb-3">
                <label for="searchtext">TEXT TO SEARCH FOR</label>
                <%= form.text_area :searchtext, required: true, cols: "84", rows: "2", placeholder: "Enter what you are searching with here..."%>
              </div>
            </div>
            <div class="row">
              <div class="col-md-6 mb-3">
                <label for="textcontent">TEXT TO SEARCH AGAINST</label>
                <%= form.text_area :textcontent, required: true, cols: "84", rows: "15", placeholder: "Copy and paste the code sample here..." %>
              </div>
            </div>

            <hr class="mb-4">
            <button class="btn btn-primary btn-lg btn-block" type="submit">GET DATA</button>
          </form>
        </div>
      </div>

      <footer class="my-5 pt-5 text-muted text-center text-small">
        <p></p>
        <p class="mb-1"><img class="d-block mx-auto mb-4" src="<%= asset_path( 'tanuki.png' ) %>" alt="" width="24" height="24">GitLab Elasticsearch Analyzer</p>
        <ul class="list-inline">
        </ul>
      </footer>
    </div>
  </body>
</html>
<% end %>

app/views/home/index.html.erb
<h1 style="text-align: center"><img class="d-block mx-auto mb-4" src="<%= asset_path( 'tanuki.png' ) %>" alt="" width="72" height="72">GitLab Elasticsearch Analyzer!</h1>

<% flash.each do |type, msg| %>
  <div class="alert-<%=type%>">
    <%= msg %>
  </div>
<% end %>

<p></p>
<div id="elasticsearch">
  <%= render 'elasticsearch_form' %>
</div>

app/views/home/output.html.erb
<% flash.each do |type, msg| %>
  <div class="alert-<%=type%>">
    <%= msg %>
  </div>
<% end %>

<h1 style="text-align: center"><img class="d-block mx-auto mb-4" src="<%= asset_path( 'tanuki.png' ) %>" alt="" width="72" height="72">GitLab Elasticsearch Analyzer!</h1>


<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">
    <title>GitLab Elasticsearch Analyzer!</title>
  </head>

  <body class="bg-light">

    <div class="container">
      <div class="py-5 text-center">
      </div>

      <div class="row">

        <% if @token_explanation[4][1][:match] == "true" %>
          <div class="col-md-12 themed-grid-col" style="color: #1aaa55; background-color: #D5FFE5; padding: 15px; text-align: center;">
            <span class="glyphicon glyphicon-ok-sign" style="color: #1aaa55;" aria-hidden="true"></span>
            <span>
              SUCCESS: Searching <%= @code_search_analyzed_search_terms %> should work in search bar
            </span>
          </div>
        <% else %>
          <div class="col-md-12 themed-grid-col" style="color: #db3b21; background-color: #fbe5e1; padding: 15px; text-align: center;">
            <span class="glyphicon glyphicon-remove-circle" style="color: #db3b21;" aria-hidden="true"></span>
            <span style="text-align: center, padding: 15px">
              FAILURE: Searching <%= @code_search_analyzed_search_terms %> should *not* work in search bar
            </span>
          </div>
        <% end %>
        <br>
        </br>

        <% if @token_explanation[2][1][:match] == "false" %>
          <div class="col-md-12 themed-grid-col" style="color: #261f1b; background-color: #fbf6e1; padding: 15px; text-align: center;">
            <span class="glyphicon glyphicon-info-sign" style="color: #261f1b;" aria-hidden="true"></span>
            <span>
              In many cases, egeNGram does not find a matching token because `max_gram: 40` is too short for the search term.
            </span>
          </div>
        <% end %>

        <br>
        </br>
        <div class="col-md-12 mb-3" style="border: 1px solid #bfbfbf; border-radius: 4px 0px 0px 4px;">
          <div class="row mb-3">
            <div class="col-md-4">
              <% @token_explanation.each do |te_k, te_v| %>
                <div class="row mb-6">
                  <div class="col-md-2 themed-grid-col" style="padding: 15px;border: 1px solid #bfbfbf; text-align: center;">
                    <% if te_v[:match] == "true" %>
                      <span class="glyphicon glyphicon-ok-sign" style="color: #1aaa55; font-size: 17px" aria-hidden="true"></span>
                    <% else %>
                      <span class="glyphicon glyphicon-remove-circle" style="color: #db3b21; font-size: 17px" aria-hidden="true"></span>
                    <% end %>
                  </div>
                  <div class="col-md-8 themed-grid-col tokens" style="background-color: white;padding: 15px 15px 15px 15px; border: 1px solid #bfbfbf; font: normal 14px/1 Arial Black, Gadget, sans-serif;">
                    <%= link_to "#{te_k}", send("#{te_k}_path"), target: "_blank", style: "font: normal 20px/1 Arial Black, Gadget, sans-serif;" %>
                  </div>
                  <div class="col-md-2 themed-grid-col" style="padding: 15px;border: 1px solid #bfbfbf; text-align: center;">
                    <span class="glyphicon glyphicon-question-sign question <%= te_k %>" style="color: #707070; font-size: 17px;" aria-hidden="true"></span>
                  </div>
                </div>
              <% end %>
            </div >

            <div class="col-md-8 themed-grid-col" style="text-align: left">
              <div class="markdown">
                <%= markdown @info %>
              </div>
              <div id="whitespace" hidden class="markdown">
                <%= markdown @whitespace %>
              </div>

              <div id="code" hidden class="markdown">
                <%= markdown @code %>
              </div>

              <div id="edgeNGram_filter" hidden class="markdown">
                <%= markdown @edgeNGram %>
              </div>

              <div id="lowercase" hidden class="markdown">
                <%= markdown @lowercase %>
              </div>

              <div id="asciifolding" hidden class="markdown">
                <%= markdown @asciifolding %>
              </div>

            </div>
          </div>
        </div>
      </div>

      <div class="row">
        <div class="col-md-12 order-md-1" style="padding: 0px">
          <form class="needs-validation" novalidate>
            <hr class="mb-4">

            <div class="links-box">
              <div class="my-5 pt-5 text-muted text-center text-small">
                <br></br>
                <%= link_to 'View Cluster Status', status_path, target: "_blank" %>
                <br></br>
                <%= link_to 'Download All Token Files & Report',  download_file_path, target: "_blank" %>
                </br></br></br>
              </div>

            </div>
            <hr class="mb-4">
            <%= link_to "SEARCH AGAIN", root_path, class: "btn btn-primary btn-lg btn-block" %>

            <div class="row">
              <div class="col-md-6 mb-3">
              </div>
            </div>
          </form>
        </div>
      </div>

      <footer class="my-5 pt-5 text-muted text-center text-small">
        <p class="mb-1"><img class="d-block mx-auto mb-4" src="<%= asset_path( 'tanuki.png' ) %>" alt="" width="24" height="24">GitLab Elasticsearch Analyzer</p>
        <ul class="list-inline">
        </ul>
      </footer>
    </div>

  </body>
</html>

<script type="text/javascript">

  function show(id) {
    box = document.getElementById(id)
    box.removeAttribute("hidden"); 
  }

  function hide() {
    var box = document.getElementsByClassName("markdown")
    for (let item of box) {
      item.hidden = true;
    }
  }

  var list = document.getElementsByClassName("events");
  
  //TODO: Could be DRY'd?
  whitespace = document.getElementsByClassName("whitespace");
  whitespace[0].addEventListener("click", function(){
   hide()
   show("whitespace")
  });

  code = document.getElementsByClassName("code");
  code[0].addEventListener("click", function(){
   hide() 
   show("code")
  });

  edgeNGram = document.getElementsByClassName("edgeNGram_filter");
  edgeNGram[0].addEventListener("click", function(){
   hide() 
   show("edgeNGram_filter")
  });

  lowercase = document.getElementsByClassName("lowercase");
  lowercase[0].addEventListener("click", function(){
   hide() 
   show("lowercase")
  });

  asciifolding = document.getElementsByClassName("asciifolding");
  asciifolding[0].addEventListener("click", function(){
   hide() 
   show("asciifolding")
  });

</script>